/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef CHROMA_OVERLAP_ADD_PROCESSOR_H
#define CHROMA_OVERLAP_ADD_PROCESSOR_H

#include "OverlapAdd.h"

class Spectrogram;
class ChromaScale;
class ChromaOverlapAddProcessor : public OverlapAddProcessor
{
public:
    ChromaOverlapAddProcessor(int fftSize, double sampleRate,
                              Spectrogram *spectro, int chanNum);
    virtual ~ChromaOverlapAddProcessor();
    
    static int FreqBinToChromaBin(int freqBin, int numBins, double hzPerBin,
                                  double c0Freq, double toneMult);
                          
protected:
    void ProcessFFT(vector<SAMPLE> *compBuf, int chanNum) override;

    void MagnsToChroma(const vector<SAMPLE> &magns,
                       vector<SAMPLE> *chroma);

    ChromaScale *_chromaScale;
    
    int _chanNum;
    
    double _sampleRate;
    
    Spectrogram *_spectro;
    int _currentSpectroCol;

    vector<SAMPLE> _tmpBuf;
    vector<SAMPLE> _tmpBuf2;
};

#endif
