/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef EFFECTS_BOX_H
#define EFFECTS_BOX_H

#include <vector>
using namespace std;

#include "Globals.h"

class Effect;
class UIEffectsCanvas;
class Serializer;
class EffectsBox
{
public:
    enum EffectIdx
    {
        EFFECT_BIT_CRUSH = 0,
        EFFECT_SATURATION,
        EFFECT_DELAY,
        EFFECT_STEREO,
        EFFECT_REVERB,
        EFFECT_VOLUME,
        NUM_EFFECTS
    };
    
    EffectsBox();
    virtual ~EffectsBox();

    void RegisterUI(UIEffectsCanvas *ui);
    
    void Process(vector<SAMPLE> *buffer, int nFrames, int nChan);

    void Serialize(Serializer *serializer);
    void UnSerialize(Serializer *serializer);
    
protected:
    Effect *_effects[NUM_EFFECTS];
};

#endif
