/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdlib.h>

#include "Stk.h"

#include "Time.h"

//#define USE_SAMPLE_FLOAT 1
#define USE_SAMPLE_DOUBLE 1

#if USE_SAMPLES_DOUBLE
#define SAMPLE double
#else
#define SAMPLE float
#endif

//#define FORMAT RTAUDIO_FLOAT64
#define FORMAT RTAUDIO_FLOAT32

//#define SRATE 44100

#define CHANNELS 2

#define BLOCK_SIZE 1024 //256 //64 //1024

#define ENVELOPE_LEN 2048

#define MIN_APP_ZOOM 0.25

// function to produce a random float
#define randf() ( ((float)rand())/RAND_MAX )

#define randd() ( ((double)rand())/RAND_MAX )

// Attenuation to prevent clipping
#define ATTENUATION 0.5;

//#define FPS 25.0
//#define FPS 60.0
#define FPS -1.0 // for default

#define DIM_FACTOR 0.5

// Makes artifacts on the waveform near 0 
#define WAVEFORM_DISPLAY_DB 0 //1

#ifndef M_PI
#define M_PI 3.141592653589793
#endif

#ifndef TWO_PI
#define TWO_PI 6.2831853071795862
#endif

#define SESSION_FILENAME "session.bin"

#define SPECTRO_FFT_SIZE 2048
#define SPECTRO_OVERLAP 4

#define STEREOIZE_BI_MONO 0

#endif
