/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef MY_RTAUDIO_H
#define MY_RTAUDIO_H

#include "RtAudio.h"

#include <cstdio>
#include <stdio.h>
#include <cstdlib>
#include <stdlib.h>

class MyRtAudio
{
public:
    virtual ~MyRtAudio();
    
    MyRtAudio(unsigned int numIns,
              unsigned int numOuts,
              unsigned int srate,
              unsigned int *bufferSize,
              RtAudioFormat format,
              bool showWarnings);
    
    void OpenStream(RtAudioCallback callback);
    
    unsigned int GetBufferSize();
    
    void StartStream();
    void StopStream();
    
    void CloseStream();
    
    void ReportStreamLatency();
       
protected:
    RtAudio *_audio;
    unsigned int _numInputs;
    unsigned int _numOutputs;
    
    unsigned int * _bufferSize;
    unsigned int _sampleRate;
    RtAudioFormat _format;
};

#endif
