/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <math.h>

#include "Ops.h"

SAMPLE
Ops::Sum(const vector<SAMPLE> &buf)
{
    SAMPLE sum = 0.0;
    for (int i = 0; i < buf.size(); i++)
        sum += buf[i];

    return sum;
}

void
Ops::Mult(vector<SAMPLE> *buf, SAMPLE v)
{
    for (int i = 0; i < buf->size(); i++)
        (*buf)[i] *= v;
}

SAMPLE
Ops::Cmp(const vector<SAMPLE> &buf0, const vector<SAMPLE> &buf1)
{
    SAMPLE sum = 0.0;
    
    for (int i = 0; i < buf0.size(); i++)
        sum += fabs(buf0[i] - buf1[i]);

    sum /= buf0.size();

    return sum;
}
