/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PARAMETER_PROVIDER_H
#define PARAMETER_PROVIDER_H

class Parameter;
class ParameterProvider
{
public:
    enum Type
    {
        UNDEFINED_TYPE = -1,
        SOURCE,
        SOUND_RECT
    };

    ParameterProvider();
    virtual ~ParameterProvider();
    
    virtual Type GetParamProviderType() const;
    
    virtual Parameter *GetCurrentParameter() = 0;
    virtual Parameter *GetParameter(int paramIdx) = 0;
    virtual int GetNumParams() const = 0;
    
    virtual double GetUIX() const = 0;
    virtual double GetUIY() const = 0;
    virtual double GetUIRadius() const = 0;

protected:
    Type _paramProviderType;
};

#endif
