/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PITCH_SHIFT_OVERLAP_ADD_PROCESSOR_H
#define PITCH_SHIFT_OVERLAP_ADD_PROCESSOR_H

#include "OverlapAdd.h"

class PitchShiftOverlapAddProcessor : public OverlapAddProcessor
{
public:
    PitchShiftOverlapAddProcessor(int fftSize, double sampleRate);
    virtual ~PitchShiftOverlapAddProcessor();

    void SetPitchShift(double pitchShift);
    
    void ProcessOutSamples(vector<SAMPLE> *buff, int chanNum) override;

protected:
    int _fftSize;
    double _sampleRate;

    double _pitchShift;
};

#endif
