/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef REVERB_EFFECT_H
#define REVERB_EFFECT_H

#include "Effect.h"

class Reverb;
class Parameter;
class ReverbEffect : public Effect
{
public:
    enum ParamIdx
    {
        ON_PARAM = 0,
        ORDER_PARAM,
        FEED_DRY_IN_PARAM,
        FEED_WET_OUT_PARAM,
        DRY_MIX_PARAM,
        DELAY_TIME_PARAM,
        DECAY_PARAM,
        NUM_PARAMS
    };
    
    ReverbEffect();
    virtual ~ReverbEffect();
    
    void Process(vector<SAMPLE> *buffer, int nFrames, int nChan) override;

    Parameter *GetParameter(ParamIdx paramIdx);

    void Serialize(Serializer *serializer) override;
    void UnSerialize(Serializer *serializer) override;
    
protected:
    void UpdateParameters();
        
    Reverb *_reverbs[2];

    Parameter *_params[NUM_PARAMS];
};

#endif
