/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SAMPLES_PROVIDER_H
#define SAMPLES_PROVIDER_H

#include <vector>
using namespace std;

#include "Globals.h"

class SamplesProvider
{
public:
    SamplesProvider() {}
    virtual ~SamplesProvider() {}
    
    virtual SamplesProvider *Clone() const = 0;
    
    virtual void SetParamY(double paramY) = 0;
    virtual void SetRange(double range) = 0;
    
    virtual int GetNumSamples() const = 0;
    virtual int GetNumChannels() const = 0;
    virtual int GetNumFrames() const = 0;

    virtual int GetBlockMinSamples() const = 0;

    virtual bool InternalPitchShift() const = 0;
    
    // start and end are position in frames
    virtual void GetSamples(vector<SAMPLE> *samples, double start, double end,
                            double timeStretch, double direction, double pitch) const = 0;
};

#endif
