/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SCALE_H
#define SCALE_H

class Scale
{
public:
    enum Type
    {
        LINEAR = 0,
        LOG,
        MEL
    };

    static double DbToAmp(double db);
    
    static double AmpToDbNorm(double amp, double minDb, double maxDb);
    
    static double HzPerBin(int fftSize, double sampleRate);
    
    static double HzToMel(double freqHz);
    static double MelToHz(double freqMel);
    
    static double Sigmoid(double t, double a);
};

#endif
