/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERIALIZER_H
#define SERIALIZER_H

#include <stdio.h>

#include <vector>
using namespace std;

class Serializer
{
public:
    Serializer();
    virtual ~Serializer();

    bool OpenReadFile(const char *fileName);
    bool OpenWriteFile(const char *fileName);
    void CloseFile();

    void PutBool(bool value);
    void GetBool(bool *value);
    
    void PutInt(int value);
    void GetInt(int *value);
    
    void PutFloat(float value);
    void GetFloat(float *value);

    void PutLong(long value);
    void GetLong(long *value);
    
    void PutDouble(double value);
    void GetDouble(double *value);

protected:
    FILE *_file;

    bool _fileReadMode;
    int _readIndex;
    vector<char> _stream;
};

#endif
