/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SPECTRO_TO_SAMPLES_H
#define SPECTRO_TO_SAMPLES_H

#include <vector>
using namespace std;

#include "Globals.h"

class Spectrogram;
class OverlapAdd;
class OverlapAddProcessor;
class PitchShiftOverlapAddProcessor;
class SpectroToSamples
{
public:
    SpectroToSamples(OverlapAddProcessor *processor);
    virtual ~SpectroToSamples();

    SpectroToSamples *Clone() const;
    
    void Process(vector<SAMPLE> *samples, double selSamples[2],
                 double selFreq[2],
                 double timeStretch, double direction, double pitchShift);

protected:
    OverlapAdd *_overlapAdd;
    OverlapAddProcessor *_processor;
    PitchShiftOverlapAddProcessor *_pitchProcessor;
};

#endif
