/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef STEREO_WIDENER_H
#define STEREO_WIDENER_H

#include <vector>
using namespace std;

#include "Globals.h"
#include "Complex.h"

class StereoWidener
{
public:
    StereoWidener();
    virtual ~StereoWidener();

    void Process(vector<SAMPLE> *buffer, int nFrames, int nChan, double widthFactor);
    
protected:
    Complex ComputeAngle0();
    Complex ComputeAngle1();

    void StereoWiden(SAMPLE *l, SAMPLE *r,
                     double widthFactor,
                     const Complex &angle0,
                     const Complex &angle1);
        
    // Complex values
    Complex _angle0;
    Complex _angle1;
};

#endif
