/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef UI_EFFECT_H
#define UI_EFFECT_H

#include <vector>
using namespace std;

#include "UICanvas.h"

class UIEffectWidget;
class UIEffect : public UICanvas
{
public:
    enum ParamIdx
    {
        ON_PARAM = 0
    };
    
    UIEffect(UIScreen *screen,
             UIStyle *style,
             const char *title,
             double x, double y,
             double width, double height,
             int numParams);
    virtual ~UIEffect();

    void SetVisible(bool flag) override;
    
    virtual void OnMouse(int button, int state, double x, double y);
    virtual void OnMouseDrag(double x, double y, double fineDragFactor = 1.0);

    void SetParameter(int idx, Parameter *param);
    
protected:
    // Generate the conntents common to all effetcts
    void GenerateContents();
    
    void DrawContents() override;

    void UpdateParameters();
    
    vector<UIEffectWidget *> _widgets;
};

#endif
