/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef UI_EFFECT_WIDGET_H
#define UI_EFFECT_WIDGET_H

#include "UICanvas.h"

class Parameter;
class UIEffectWidget : public UICanvas
{
public:
    UIEffectWidget(UIScreen *screen,
                   UIStyle *style,
                   const char *title,
                   double x, double y,
                   double width, double height);
    virtual ~UIEffectWidget();

    void SetParameter(Parameter *param);
    Parameter *GetParameter();
    
    void Draw();

    void OnMouse(int button, int state, double x, double y) override;
    
protected:
    virtual void DrawWidget() = 0;
    
    void DrawTitle();
    void DrawValue();
    
    char _title[255];

    bool _leftMouseDown;

    Parameter *_param;
};

#endif
