/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef UI_EFFECTS_CANVAS_H
#define UI_EFFECTS_CANVAS_H

#include <vector>
using namespace std;

#include "EffectsBox.h"
#include "UICanvas.h"

class UIEffect;
class UIEffectsCanvas : public UICanvas
{
public:
    UIEffectsCanvas(UIScreen *screen,
                    UIStyle *style,
                    const char *title,
                    double x, double y,
                    double width, double height);
    virtual ~UIEffectsCanvas();

    void SetVisible(bool flag) override;

    virtual void OnMouse(int button, int state, double x, double y) override;
    virtual void OnMouseDrag(double x, double y, double fineDragFactor = 1.0) override;
    
    UIEffect *GetEffect(EffectsBox::EffectIdx effectIdx);
    
protected:
    void DrawContents() override;
    
    void GenerateContents();

    UIEffect *_effects[EffectsBox::NUM_EFFECTS];
};

#endif
