/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef UI_LFO_WINDOW_H
#define UI_LFO_WINDOW_H

#include "UIWindow.h"

class UILFOWindow : public UIWindow
{
 public:
    UILFOWindow(UIScreen *screen,
                UIStyle *style,
                const char *title,
                double x, double y,
                double width, double height);
    virtual ~UILFOWindow();

    void SetFreq(double freq);
    void SetAmp(double amp);

 protected:
    void GenerateContents();
    
    double _freq;
    double _amp;

    double _buffer[256];
};

#endif
