/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */
 
#ifndef UI_PIE_MENU_H
#define UI_PIE_MENU_H

#include "App.h"

class App;
class UIScreen;
class UIPieMenu
{
public:
    UIPieMenu(App *_app,
              UIScreen *screen);
    virtual ~UIPieMenu();

    void InitFromParameters();
    void UpdateCurrentParamPos();
    
    bool IsVisible() const;
    void SetVisible(bool flag);
    
    void Draw();

    bool OnMouse(int button, int state, double x, double y);
    void OnMouseDrag(double dx, double dy);
    
protected:    
    App *_app;
    UIScreen *_screen;
    
    bool _visible;
};

#endif
