/* Copyright (C) 2022 Nicolas Dittlo <deadlab.plugins@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this software; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>

#include "UIStyle.h"

void
UIStyle::GetAppName(char appName[512])
{
    sprintf(appName, _appName);
}

void
UIStyle::GetBackgroundColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _backgroundColor[i];
}

double
UIStyle::GetAxisLineWidth() const
{
    return _axisLineWidth;
}

void
UIStyle::GetAxisXColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _axisXColor[i];
}

void
UIStyle::GetAxisYColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _axisYColor[i];
}

void
UIStyle::GetAxisZColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _axisZColor[i];
}

double
UIStyle::GetTitleLineWidth() const
{
    return _titleLineWidth;
}

void
UIStyle::GetTitleAColorCoeff(double colCoeff[4]) const
{
    for (int i = 0; i < 4; i++)
        colCoeff[i] = _titleAColCoeff[i];
}

void
UIStyle::GetTitleInsColorCoeff(double colCoeff[4]) const
{
    for (int i = 0; i < 4; i++)
        colCoeff[i] = _titleInsColCoeff[i];
}

double
UIStyle::GetHelpLineWidth() const
{
    return _helpLineWidth;
}

void
UIStyle::GetHelpInsColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _helpInsColor[i];
}

void
UIStyle::GetHelpBackgroundColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _helpBackgroundColor[i];
}

double
UIStyle::GetParamLineWidth() const
{
    return _paramLineWidth;
}

void
UIStyle::GetParamColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _paramColor[i];
}

double
UIStyle::GetParamMeterLineWidth() const
{
    return _paramMeterLineWidth;
}

void
UIStyle::GetParamMeterColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _paramMeterColor[i];
}

double
UIStyle::GetParamLinkLineWidth() const
{
    return _paramLinkLineWidth;
}

void
UIStyle::GetParamLinkColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _paramLinkColor[i];
}

void
UIStyle::GetGrainColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _grainColor[i];
}

void
UIStyle::GetGrainColorSelected(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _grainColorSelected[i];
}

void
UIStyle::GetGrainDrawColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _grainVisColor[i];
}

void
UIStyle::GetGrainDrawDefColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _grainVisDefColor[i];
}

void
UIStyle::GetSoundRectColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _soundRectColor[i];
}

void
UIStyle::GetSoundRectColorSelected(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _soundRectColorSelected[i];
}

void
UIStyle::GetSoundRectBorderColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _soundRectBorderColor[i];
}

void
UIStyle::GetSoundRectBorderColorSelected(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _soundRectBorderColorSelected[i];
}

double
UIStyle::GetSoundRectLineWidth() const
{
    return _soundRectLineWidth;
}

void
UIStyle::GetWaveColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _waveColor[i];
}

double
UIStyle::GetWaveLineWidth() const
{
    return _waveLineWidth;
}

double
UIStyle::GetWavePointSize() const
{
    return _wavePointSize;
}

void
UIStyle::GetSoundRectNameColor(double col[4]) const
{
    col[0] = _soundRectNameColor[0];
    col[1] = _soundRectNameColor[1];
    col[2] = _soundRectNameColor[2];
    col[3] = _soundRectNameColor[3];
}

void
UIStyle::GetSoundRectNameColorSelected(double col[4]) const
{
    col[0] = _soundRectNameColorSelected[0];
    col[1] = _soundRectNameColorSelected[1];
    col[2] = _soundRectNameColorSelected[2];
    col[3] = _soundRectNameColorSelected[3];
}

void
UIStyle::GetUIWindowBackgroundColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _uiWindowBackgroundColor[i];
}

void
UIStyle::GetUIWindowBorderColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _uiWindowBorderColor[i];
}

double
UIStyle::GetUIWindowBorderWidth() const
{
    return _uiWindowBorderWidth;
}

void
UIStyle::GetUIWindowTitleColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _uiWindowTitleColor[i];
}

double
UIStyle::GetUIWindowTitleBoxBorderWidth() const
{
    return _uiWindowTitleBoxBorderWidth;
}

void
UIStyle::GetUIWindowContentsColor(double col[4]) const
{
    for (int i = 0; i < 4; i++)
        col[i] = _uiWindowContentsColor[i];
}

double
UIStyle::GetUIWindowContentsLineWidth() const
{
    return _uiWindowContentsLineWidth;
}

// Default style
DefaultStyle::DefaultStyle()
{
    sprintf(_appName, "BORDERLANDS");
    
    _backgroundColor[0] = 0.15;
    _backgroundColor[1] = 0.15;
    _backgroundColor[2] = 0.15;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
    
    _helpInsColor[0] = 0.6;
    _helpInsColor[1] = 0.6;
    _helpInsColor[2] = 0.6;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 1.0;
    _paramColor[1] = 1.0;
    _paramColor[2] = 1.0;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;
    
    _grainColor[0] = 0.1;
    _grainColor[1] = 0.7;
    _grainColor[2] = 0.6;
    _grainColor[3] = 0.35;
    
    _grainColorSelected[0] = 0.0;
    _grainColorSelected[1] = 0.4;
    _grainColorSelected[2] = 0.7;
    _grainColorSelected[3] = 0.3;

    _grainVisColor[0] = 1.0;
    _grainVisColor[1] = 0.0;
    _grainVisColor[2] = 0.0;
    _grainVisColor[3] = 0.6;

    _grainVisDefColor[0] = 1.0;
    _grainVisDefColor[1] = 0.0;
    _grainVisDefColor[2] = 0.0;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 1.0;
    _soundRectColor[1] = 1.0;
    _soundRectColor[2] = 1.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 0.7;
    _soundRectBorderColor[1] = 0.7;
    _soundRectBorderColor[2] = 0.7;
    _soundRectBorderColor[3] = 0.3;
    
    _soundRectBorderColorSelected[0] = 0.7;
    _soundRectBorderColorSelected[1] = 0.7;
    _soundRectBorderColorSelected[2] = 0.7;
    _soundRectBorderColorSelected[3] = 0.7;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 1.0;
    _uiWindowBackgroundColor[1] = 1.0;
    _uiWindowBackgroundColor[2] = 1.0;
    _uiWindowBackgroundColor[3] = 0.25;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

DefaultStyle::~DefaultStyle() {}

// Purple stype
PurpleStyle::PurpleStyle()
{
    sprintf(_appName, "SILENCE---");
    
    _backgroundColor[0] = 0.23;
    _backgroundColor[1] = 0.20;
    _backgroundColor[2] = 0.46;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
    
    _helpInsColor[0] = 1.0;
    _helpInsColor[1] = 1.0;
    _helpInsColor[2] = 1.0;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 0.98;
    _paramColor[1] = 0.63;
    _paramColor[2] = 0.92;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;
    
    _grainColor[0] = 0.71;
    _grainColor[1] = 0.40;
    _grainColor[2] = 1.0;
    _grainColor[3] = 0.5;
    
    _grainColorSelected[0] = 0.71;
    _grainColorSelected[1] = 0.40;
    _grainColorSelected[2] = 1.0;
    _grainColorSelected[3] = 0.9;

    _grainVisColor[0] = 0.81;
    _grainVisColor[1] = 0.0;
    _grainVisColor[2] = 1.0;
    _grainVisColor[3] = 0.9;

    _grainVisDefColor[0] = 0.81;
    _grainVisDefColor[1] = 0.0;
    _grainVisDefColor[2] = 1.0;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 1.0;
    _soundRectColor[1] = 0.60;
    _soundRectColor[2] = 1.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 0.8;
    _soundRectBorderColor[1] = 0.8;
    _soundRectBorderColor[2] = 0.5;
    _soundRectBorderColor[3] = 0.1;
    
    _soundRectBorderColorSelected[0] = 0.8;
    _soundRectBorderColorSelected[1] = 0.8;
    _soundRectBorderColorSelected[2] = 0.5;
    _soundRectBorderColorSelected[3] = 0.7;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 1.0;
    _uiWindowBackgroundColor[1] = 1.0;
    _uiWindowBackgroundColor[2] = 1.0;
    _uiWindowBackgroundColor[3] = 0.25;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

PurpleStyle::~PurpleStyle() {}

// Jellyfish style
JellyfishStyle::JellyfishStyle()
{
    sprintf(_appName, "MEDUSA");
    
    _backgroundColor[0] = 0.0;
    _backgroundColor[1] = 1.0;
    _backgroundColor[2] = 1.0;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
   
    _helpInsColor[0] = 1.0;
    _helpInsColor[1] = 1.0;
    _helpInsColor[2] = 1.0;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 1.0;
    _paramColor[1] = 1.0;
    _paramColor[2] = 1.0;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;
    
    _grainColor[0] = 1.0;
    _grainColor[1] = 1.0;
    _grainColor[2] = 1.0;
    _grainColor[3] = 0.5;
    
    _grainColorSelected[0] = 1.0;
    _grainColorSelected[1] = 1.0;
    _grainColorSelected[2] = 1.0;
    _grainColorSelected[3] = 0.9;

    _grainVisColor[0] = 0.42;
    _grainVisColor[1] = 0.34;
    _grainVisColor[2] = 1.0;
    _grainVisColor[3] = 0.9;

    _grainVisDefColor[0] = 0.42;
    _grainVisDefColor[1] = 0.34;
    _grainVisDefColor[2] = 1.0;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 1.0;
    _soundRectColor[1] = 0.0;
    _soundRectColor[2] = 1.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 1.0;
    _soundRectBorderColor[1] = 0.0;
    _soundRectBorderColor[2] = 1.0;
    _soundRectBorderColor[3] = 0.3;
    
    _soundRectBorderColorSelected[0] = 1.0;
    _soundRectBorderColorSelected[1] = 0.0;
    _soundRectBorderColorSelected[2] = 1.0;
    _soundRectBorderColorSelected[3] = 0.6;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 0.0;
    _uiWindowBackgroundColor[1] = 0.0;
    _uiWindowBackgroundColor[2] = 0.0;
    _uiWindowBackgroundColor[3] = 0.5;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

JellyfishStyle::~JellyfishStyle() {}

// Psytrance style
PsytranceStyle::PsytranceStyle()
{
    sprintf(_appName, "SILENCE---");
    
    _backgroundColor[0] = 0.0;
    _backgroundColor[1] = 0.0;
    _backgroundColor[2] = 0.0;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
    
    _helpInsColor[0] = 1.0;
    _helpInsColor[1] = 1.0;
    _helpInsColor[2] = 1.0;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 1.0;
    _paramColor[1] = 1.0;
    _paramColor[2] = 1.0;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;
    
    _grainColor[0] = 0.0;
    _grainColor[1] = 0.33;
    _grainColor[2] = 1.0;
    _grainColor[3] = 0.5;
    
    _grainColorSelected[0] = 0.0;
    _grainColorSelected[1] = 0.33;
    _grainColorSelected[2] = 1.0;
    _grainColorSelected[3] = 0.9;

    _grainVisColor[0] = 1.0;
    _grainVisColor[1] = 0.0;
    _grainVisColor[2] = 1.0;
    _grainVisColor[3] = 0.9;

    _grainVisDefColor[0] = 1.0;
    _grainVisDefColor[1] = 0.0;
    _grainVisDefColor[2] = 1.0;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 0.0;
    _soundRectColor[1] = 1.0;
    _soundRectColor[2] = 0.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 0.0;
    _soundRectBorderColor[1] = 1.0;
    _soundRectBorderColor[2] = 0.0;
    _soundRectBorderColor[3] = 0.3;
    
    _soundRectBorderColorSelected[0] = 0.0;
    _soundRectBorderColorSelected[1] = 1.0;
    _soundRectBorderColorSelected[2] = 0.0;
    _soundRectBorderColorSelected[3] = 1.0;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 0.0;
    _uiWindowBackgroundColor[1] = 0.0;
    _uiWindowBackgroundColor[2] = 0.0;
    _uiWindowBackgroundColor[3] = 0.5;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

PsytranceStyle::~PsytranceStyle() {}

// Black n white style
BlackNWhiteStyle::BlackNWhiteStyle()
{
    sprintf(_appName, "NECRO PHONE");
    
    _backgroundColor[0] = 0.0;
    _backgroundColor[1] = 0.0;
    _backgroundColor[2] = 0.0;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
    
    _helpInsColor[0] = 1.0;
    _helpInsColor[1] = 1.0;
    _helpInsColor[2] = 1.0;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 1.0;
    _paramColor[1] = 1.0;
    _paramColor[2] = 1.0;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;

    _grainColor[0] = 1.0;
    _grainColor[1] = 1.0;
    _grainColor[2] = 1.0;
    _grainColor[3] = 0.5;
    
    _grainColorSelected[0] = 1.0;
    _grainColorSelected[1] = 1.0;
    _grainColorSelected[2] = 1.0;
    _grainColorSelected[3] = 0.9;

    _grainVisColor[0] = 1.0;
    _grainVisColor[1] = 1.0;
    _grainVisColor[2] = 1.0;
    _grainVisColor[3] = 0.9;

    _grainVisDefColor[0] = 1.0;
    _grainVisDefColor[1] = 1.0;
    _grainVisDefColor[2] = 1.0;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 0.0;
    _soundRectColor[1] = 0.0;
    _soundRectColor[2] = 0.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 1.0;
    _soundRectBorderColor[1] = 1.0;
    _soundRectBorderColor[2] = 1.0;
    _soundRectBorderColor[3] = 0.3;
    
    _soundRectBorderColorSelected[0] = 1.0;
    _soundRectBorderColorSelected[1] = 1.0;
    _soundRectBorderColorSelected[2] = 1.0;
    _soundRectBorderColorSelected[3] = 1.0;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 0.0;
    _uiWindowBackgroundColor[1] = 0.0;
    _uiWindowBackgroundColor[2] = 0.0;
    _uiWindowBackgroundColor[3] = 0.5;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

BlackNWhiteStyle::~BlackNWhiteStyle() {}

// Slug style
SlugStyle::SlugStyle()
{
    sprintf(_appName, "SONIC MIXER");
    
    _backgroundColor[0] = 0.0;
    _backgroundColor[1] = 0.0;
    _backgroundColor[2] = 0.0;
    _backgroundColor[3] = 1.0;

    _axisLineWidth = 0.9;
    
    _axisXColor[0] = 1.0;
    _axisXColor[1] = 0.0;
    _axisXColor[2] = 0.0;
    _axisXColor[3] = 0.9;

    _axisYColor[0] = 0.0;
    _axisYColor[1] = 1.0;
    _axisYColor[2] = 0.0;
    _axisYColor[3] = 0.9;

    _axisZColor[0] = 0.0;
    _axisZColor[1] = 0.0;
    _axisZColor[2] = 1.0;
    _axisZColor[3] = 0.7;

    _titleLineWidth = 2.0;
    
    _titleAColCoeff[0] = 1.0;
    _titleAColCoeff[1] = 1.0;
    _titleAColCoeff[2] = 1.0;
    _titleAColCoeff[3] = 1.0;

    _titleInsColCoeff[0] = 1.0;
    _titleInsColCoeff[1] = 1.0;
    _titleInsColCoeff[2] = 1.0;
    _titleInsColCoeff[3] = 1.0;

    _helpLineWidth = 2.0;
    
    _helpInsColor[0] = 1.0;
    _helpInsColor[1] = 1.0;
    _helpInsColor[2] = 1.0;
    _helpInsColor[3] = 0.6;

    _helpBackgroundColor[0] = 0.0;
    _helpBackgroundColor[1] = 0.0;
    _helpBackgroundColor[2] = 0.0;
    _helpBackgroundColor[3] = 0.5;
    
    _paramLineWidth = 2.0;
    
    _paramColor[0] = 1.0;
    _paramColor[1] = 1.0;
    _paramColor[2] = 1.0;
    _paramColor[3] = 1.0;

    _paramMeterLineWidth = 4.0;
    
    _paramMeterColor[0] = 1.0;
    _paramMeterColor[1] = 1.0;
    _paramMeterColor[2] = 1.0;
    _paramMeterColor[3] = 1.0;
    
    _paramLinkLineWidth = 2.0;
    
    _paramLinkColor[0] = 1.0;
    _paramLinkColor[1] = 1.0;
    _paramLinkColor[2] = 1.0;
    _paramLinkColor[3] = 1.0;

    _grainColor[0] = 0.45;
    _grainColor[1] = 0.58;
    _grainColor[2] = 0.62;
    _grainColor[3] = 0.5;
    
    _grainColorSelected[0] = 0.45;
    _grainColorSelected[1] = 0.58;
    _grainColorSelected[2] = 0.62;
    _grainColorSelected[3] = 0.9;

    _grainVisColor[0] = 0.45;
    _grainVisColor[1] = 0.58;
    _grainVisColor[2] = 0.62;
    _grainVisColor[3] = 0.9;

    _grainVisDefColor[0] = 0.45;
    _grainVisDefColor[1] = 0.58;
    _grainVisDefColor[2] = 0.62;
    _grainVisDefColor[3] = 1.0;
    
    _soundRectColor[0] = 0.0;
    _soundRectColor[1] = 0.0;
    _soundRectColor[2] = 0.0;
    _soundRectColor[3] = 0.3;

    _soundRectBorderColor[0] = 1.0;
    _soundRectBorderColor[1] = 0.0;
    _soundRectBorderColor[2] = 0.0;
    _soundRectBorderColor[3] = 0.3;
    
    _soundRectBorderColorSelected[0] = 1.0;
    _soundRectBorderColorSelected[1] = 0.0;
    _soundRectBorderColorSelected[2] = 0.0;
    _soundRectBorderColorSelected[3] = 1.0;

    _soundRectLineWidth = 3.0;

    _waveColor[0] = 1.0;
    _waveColor[1] = 1.0;
    _waveColor[2] = 1.0;
    _waveColor[3] = 0.3;

    _waveLineWidth = 1.5;
    _wavePointSize = 1.0;

    _soundRectNameColor[0] = 1.0;
    _soundRectNameColor[1] = 1.0;
    _soundRectNameColor[2] = 1.0;
    _soundRectNameColor[3] = 0.35;

    _soundRectNameColorSelected[0] = 1.0;
    _soundRectNameColorSelected[1] = 1.0;
    _soundRectNameColorSelected[2] = 1.0;
    _soundRectNameColorSelected[3] = 1.0;

    // UIWindow
    _uiWindowBackgroundColor[0] = 0.0;
    _uiWindowBackgroundColor[1] = 0.0;
    _uiWindowBackgroundColor[2] = 0.0;
    _uiWindowBackgroundColor[3] = 0.5;

    _uiWindowBorderColor[0] = 1.0;
    _uiWindowBorderColor[1] = 1.0;
    _uiWindowBorderColor[2] = 1.0;
    _uiWindowBorderColor[3] = 1.0;

    _uiWindowBorderWidth = 2.5;

    _uiWindowTitleColor[0] = 1.0;
    _uiWindowTitleColor[1] = 1.0;
    _uiWindowTitleColor[2] = 1.0;
    _uiWindowTitleColor[3] = 1.0;

    _uiWindowTitleBoxBorderWidth = 1.0;

    _uiWindowContentsColor[0] = 1.0;
    _uiWindowContentsColor[1] = 1.0;
    _uiWindowContentsColor[2] = 1.0;
    _uiWindowContentsColor[3] = 1.0;
    
    _uiWindowContentsLineWidth = 2.0;
}

SlugStyle::~SlugStyle() {}
